package org.processmining.plugins.resourcePattern;

import java.util.Date;
import java.util.TreeMap;

public class ActivityInstance {
	private Integer inIndex;
	private Integer outIndex;
	private Date inTS;
	private Date outTS;
	private Double queueScore;
	private WorkItem wi;
	private TreeMap<WorkItem, Integer> currentInQueueAtOut;
	private Double adjustedScore;
	private Double retainFactor;
	
	public Double getAdjustedScore() {
		return adjustedScore;
	}

	public void setAdjustedScore(Double adjustedScore) {
		this.adjustedScore = adjustedScore;
	}

	public ActivityInstance(WorkItem wi){
		this.wi = wi;
	}
	
	public WorkItem getWi() {
		return wi;
	}

	public void setWi(WorkItem wi) {
		this.wi = wi;
	}

	
	
	public Integer getInIndex() {
		return inIndex;
	}


	public void setInIndex(Integer inIndex) {
		this.inIndex = inIndex;
	}

	public Integer getOutIndex() {
		return outIndex;
	}

	public void setOutIndex(Integer outIndex) {
		this.outIndex = outIndex;
	}

	public Date getInTS() {
		return inTS;
	}

	public void setInTS(Date inTS) {
		this.inTS = inTS;
	}

	public Date getOutTS() {
		return outTS;
	}

	public void setOutTS(Date outTS) {
		this.outTS = outTS;
	}

	public Double getQueueScore() {
		return queueScore;
	}

	public void setQueueScore(Double queueScore) {
		this.queueScore = queueScore;
	}
	
	@Override
	public String toString() {
		String toPrint=null;
		toPrint = "caseID: " + this.wi.getCaseID() + ", activity: " + this.wi.getActivity() + ", resource: " + this.wi.getResource() + ", timestampIn: "+ this.inTS + ", inIndex: " +
		this.inIndex + ", outIndex: " + this.outIndex + ", queueScore: "+ this.getQueueScore() + ", adjustedScore: " + this.getAdjustedScore() + ", retainFactor: " + this.getRetainFactor();
		
		return toPrint;
	}

	public TreeMap<WorkItem, Integer> getCurrentInQueueAtOut() {
		return currentInQueueAtOut;
	}

	public void setCurrentInQueueAtOut(TreeMap<WorkItem, Integer> currentInQueueAtOut) {
		this.currentInQueueAtOut = currentInQueueAtOut;
	}

	public Double getRetainFactor() {
		return retainFactor;
	}

	public void setRetainFactor(Double retainFactor) {
		this.retainFactor = retainFactor;
	}




}
