package org.processmining.plugins.resourcePattern;

import java.util.HashMap;

import org.processmining.plugins.resourcePattern.utility.Event;

public class WorkItem implements Comparable<WorkItem> {
	private String caseID = null;
	private String activity = null;
	private String resource = null;
	private String resourceGroup = null;
	private HashMap<String, String> eventAttributes = null;
	private Integer taskInstance = null;
	
	public WorkItem(String caseID, String activity, String resource, String resourceGroup,
			HashMap<String,String> eventAttributes, Integer taskInstance) {
		this.caseID=caseID;
		this.activity=activity;
		this.resource=resource;
		this.resourceGroup=resourceGroup;
		this.taskInstance=taskInstance;
		this.eventAttributes=eventAttributes;
	}
	
	public WorkItem(Event e) {
		this.caseID=e.getCaseID();
		this.activity=e.getActivity();
		this.resource=e.getResource();
		this.resourceGroup=e.getResourceGroup();
		this.eventAttributes=e.getEventAttributes();
		this.taskInstance=e.getTaskInstance();
	}
	
	public String getCaseID() {
		return caseID;
	}
	public void setCaseID(String caseID) {
		this.caseID = caseID;
	}
	public String getActivity() {
		return activity;
	}
	public void setActivity(String activity) {
		this.activity = activity;
	}
	public String getResource() {
		return resource;
	}
	public void setResource(String resource) {
		this.resource = resource;
	}
	public String getResourceGroup() {
		return resourceGroup;
	}
	public void setResourceGroup(String resourceGroup) {
		this.resourceGroup = resourceGroup;
	}
	public HashMap<String, String> getEventAttributes() {
		return eventAttributes;
	}
	public void setEventAttributes(HashMap<String, String> eventAttributes) {
		this.eventAttributes = eventAttributes;
	}
	public Integer getTaskInstance() {
		return taskInstance;
	}
	public void setTaskInstance(Integer taskInstance) {
		this.taskInstance = taskInstance;
	}
	
	public WorkItem deepCopy(WorkItem wi) {
		return new WorkItem(wi.getCaseID(), wi.getActivity(),wi.getResource(),
				wi.getResourceGroup(),wi.getEventAttributes(),wi.getTaskInstance());
	}

	public int compareTo(WorkItem o) {
		return this.caseID.compareTo(o.caseID);
		
	}
	
	public String toString() {
		return this.getCaseID()+","+this.getActivity()+","+this.getTaskInstance();
	}

}


