package org.processmining.plugins.resourcePattern.presentation;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JRadioButton;

import org.deckfour.uitopia.api.event.TaskListener.InteractionResult;
import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.widgets.ProMComboBox;
import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.framework.util.ui.widgets.ProMTextField;
import org.processmining.plugins.resourcePattern.ConstantValues;
import org.processmining.plugins.resourcePattern.utility.Helper;

public class ConfigurationPanelWorker {
	JButton fileButton =  new JButton("Choose directory");
	JFileChooser chooser = new JFileChooser();
	ProMPropertiesPanel configurationPanel = new 
			ConfigurationPanel("Event Gap Analysis - Configuration");
	JLabel chosenDirectory = new JLabel();
	
	public HashMap<String, Object> prepareConfiguration(UIPluginContext context,
			String[] parameterNames, String[] parameterDesc, XLog log) {

		HashMap<String, Object> paramSet = new HashMap<String, Object>();
		
		
		Helper helper = new Helper();
		SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
		
		for(int i=0; i<parameterNames.length; i++) {
			if(parameterNames[i].equalsIgnoreCase(ConstantValues.paramName01startDate) ||
					parameterNames[i].equalsIgnoreCase(ConstantValues.paramName02endDate)) {
				ProMTextField textField = new ProMTextField();
				textField.setName(parameterNames[i]);
				if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName01startDate)) {
					textField.setText(sdf.format(helper.getEarliestTimestamp(log)));
				}
				if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName02endDate)) {
					textField.setText(sdf.format(helper.getLatestTimestamp(log)));
				}
				configurationPanel.addProperty(parameterDesc[i], textField);
				paramSet.put(parameterNames[i], textField);
			}
			ArrayList<String> eventAttributes=new ArrayList<String>();
			HashSet<String> transactionType = helper.getTransactionType(log);
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName03HeadType) ||
					parameterNames[i].equalsIgnoreCase(ConstantValues.paramName03ATailType)) {	
				if (transactionType.contains("schedule")) {
					eventAttributes.add("schedule");
				}
				if (transactionType.contains("assign")) {
					eventAttributes.add("assign");
				}
				if (transactionType.contains("start")) {
					eventAttributes.add("start");
				}
				if (transactionType.contains("complete")) {
					eventAttributes.add("complete");
				}
				ProMComboBox transactionTypeBox = new ProMComboBox(eventAttributes);
				configurationPanel.addProperty(parameterDesc[i], transactionTypeBox);
				
				paramSet.put(parameterNames[i], transactionTypeBox);
			}
			
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName04ResourceAnalysisType)) {
				JRadioButton decisionTreeAnalysis = new JRadioButton(ConstantValues.resourceDecisionTreeText);
				JRadioButton efficiencyAnalysis = new JRadioButton(ConstantValues.resourceEfficiencyAnalysisText);
				JRadioButton queueAnalysis = new JRadioButton(ConstantValues.resourceQueueAnalysisText);
				queueAnalysis.setSelected(true);
				ButtonGroup group = new ButtonGroup();
				//group.add(decisionTreeAnalysis);
				//group.add(efficiencyAnalysis);
				group.add(queueAnalysis);
				configurationPanel.addProperty(parameterDesc[i], new JLabel(""));
				//configurationPanel.addProperty("", decisionTreeAnalysis);
				//configurationPanel.addProperty("", efficiencyAnalysis);
				configurationPanel.addProperty("", queueAnalysis);
				//paramSet.put(parameterNames[i],	new JRadioButton[] {decisionTreeAnalysis,efficiencyAnalysis,queueAnalysis} );
				paramSet.put(parameterNames[i],	new JRadioButton[] {queueAnalysis} );
			}
			
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName_QQueueType)) {
				ArrayList<String> queueTypes = new ArrayList<String>();
				queueTypes.add(ConstantValues.queueTypeFIFO);
				queueTypes.add(ConstantValues.queueTypeLIFO);
				queueTypes.add(ConstantValues.queueTypePriority);
				ProMComboBox queueTypeBox = new ProMComboBox(queueTypes);
				configurationPanel.addProperty(parameterDesc[i], queueTypeBox);
				paramSet.put(parameterNames[i], queueTypeBox);
			}
			
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramName_QScopeType)) {
				ArrayList<String> scopeTypes = new ArrayList<String>();
				scopeTypes.add(ConstantValues.scopeTypeActivity);
				scopeTypes.add(ConstantValues.scopeTypeWorkload);
				scopeTypes.add(ConstantValues.scopeTypeCase);
				ProMComboBox scopeTypeBox = new ProMComboBox(scopeTypes);
				configurationPanel.addProperty(parameterDesc[i], scopeTypeBox);
				paramSet.put(parameterNames[i], scopeTypeBox);
			}
			
			if (parameterNames[i].equalsIgnoreCase(ConstantValues.paramDesc_QPriorityAttribute)) {
				Set<String> fieldNames = helper.getAvailableAttributes(log);
				ProMComboBox fieldNamesBox = new ProMComboBox(fieldNames);
				configurationPanel.addProperty(parameterDesc[i], fieldNamesBox);
				paramSet.put(parameterNames[i], fieldNamesBox);
			}
			
		}	
	
		InteractionResult result = context.showConfiguration("Configuration", 
				configurationPanel);
		if (result == InteractionResult.CANCEL) {
			context.getFutureResult(0).cancel(true);
			return null;
		}	

		return paramSet;
	}
	
	

}
