package org.processmining.plugins.resourcePattern.presentation;

import java.util.ArrayList;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.plugins.resourcePattern.ConstantValues;
import org.processmining.plugins.resourcePattern.queueAnalysis.presentation.mvc.QueueController;
import org.processmining.plugins.resourcePattern.queueAnalysis.presentation.mvc.QueueViewer;
import org.processmining.plugins.resourcePattern.utility.Event;

public class ResourcePatternVisualizer {

	@Plugin(name = "Resource Pattern Visualization", 
			parameterLabels = {"Resource Pattern Results Collection"},
			returnTypes = Viewer.class, 
			returnLabels = "Resource Pattern Visualization", 
			userAccessible = false, 
			help = "Visualizes the dotted chart")
	@Visualizer(name = "Resource Pattern Visualization")
	//public static Controller visualize(PluginContext context, HashMap<String, File> gapFiles) throws Exception {
	public static Controller visualize(PluginContext context, XLog log, ArrayList<Event> data, String analysisType) throws Exception {
		Viewer view=null;
		Controller controller = null;
		if (analysisType.equalsIgnoreCase(ConstantValues.resourceQueueAnalysisText)) {
			view = new QueueViewer(context, log);
			controller = new QueueController(data, (QueueViewer) view);
		} //else if (analysisType.equalsIgnoreCase(ConstantValues.resourceEfficiencyAnalysisText)) {
			//view = new GapViewer(context, log);
			//controller = new GapController(data, (GapViewer) view);
		//}
		view.setVisible(true);
		return controller;
	}
}
