package org.processmining.plugins.resourcePattern.queueAnalysis;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.TreeMap;
import java.util.TreeSet;

import org.processmining.plugins.resourcePattern.ActivityInstance;
import org.processmining.plugins.resourcePattern.WorkItem;
import org.processmining.plugins.resourcePattern.utility.Event;

public class LIFOAnalysis extends QueueAssessment {

	public LIFOAnalysis(HashMap<String, ArrayList<Event>> scopeItems, String startType, String endType, String queueOneTreatment) {
		super(scopeItems, startType, endType, queueOneTreatment);
	}

	public Integer getExpectedOutputPosition(TreeMap<WorkItem, Integer> inQueue,
			TreeMap<Integer, ActivityInstance> outputScoreList) {
		TreeSet<Integer> theValues = this.getValuesAsTreeSet(inQueue);
		
		return theValues.last();
	}

	public Integer getFurthestOutputPosition(TreeMap<WorkItem, Integer> inQueue,
			TreeMap<Integer, ActivityInstance> outputScoreList) {
		//We simply return the very first index in the
		//ordered list (the inQueue.values() method return the values in ascending order already
		TreeSet<Integer> theValues = this.getValuesAsTreeSet(inQueue);
		return theValues.first();
	}

	public Integer getClosestOutputPosition(TreeMap<WorkItem, Integer> inQueue,
			TreeMap<Integer, ActivityInstance> activityList) {
		TreeSet<Integer> theValues = this.getValuesAsTreeSet(inQueue);
		return theValues.last();
	}

}
