package org.processmining.plugins.resourcePattern.queueAnalysis;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.TreeMap;
import java.util.TreeSet;

import org.processmining.plugins.resourcePattern.ActivityInstance;
import org.processmining.plugins.resourcePattern.ConstantValues;
import org.processmining.plugins.resourcePattern.WorkItem;
import org.processmining.plugins.resourcePattern.queueAnalysis.priority.PriorityAlphabeticFIFOQueue;
import org.processmining.plugins.resourcePattern.utility.Event;

public class PriorityQueue extends QueueAssessment {
	String priorityAttributeName;
	String priorityType;
	HashMap<ActivityInstance, Integer> sortedPriorityQueue;
	
	public HashMap<ActivityInstance, Integer> getSortedPriorityQueue() {
		return sortedPriorityQueue;
	}

	public void setSortedPriorityQueue(HashMap<ActivityInstance, Integer> sortedPriorityQueue) {
		this.sortedPriorityQueue = sortedPriorityQueue;
	}

	public PriorityQueue(HashMap<String, ArrayList<Event>> scopeItems, String startType, String endType, String priorityAttributeName,
			String priorityType, String queueOneTreatment) {
		super(scopeItems, startType, endType, queueOneTreatment);
		this.priorityAttributeName = priorityAttributeName;
		this.priorityType = ConstantValues.queueTypePriorit_AlphabeticFIFO;
	}

	public Integer getExpectedOutputPosition(TreeMap<WorkItem, Integer> inQueue,
			TreeMap<Integer, ActivityInstance> outputScoreList) {
		
		//ActivityInstance referenceAI = outputScoreList.get(this.getValuesAsTreeSet(inQueue).first());
		
		if (this.priorityType.equalsIgnoreCase(ConstantValues.queueTypePriorit_AlphabeticFIFO)) {
			
			PriorityAlphabeticFIFOQueue queueClass = new PriorityAlphabeticFIFOQueue(inQueue, outputScoreList, this.priorityAttributeName); 
			//sortedPriorityQueue = queueClass.getExpectedQueue();
			return queueClass.getSortedQueue().firstEntry().getValue();
			//sortedPriorityQueue.keySet()
			
			//return sortedPriorityQueue.get(referenceAI);
		}	
		return null;
	}

	public Integer getFurthestOutputPosition(TreeMap<WorkItem, Integer> inQueue,
			TreeMap<Integer, ActivityInstance> outputScoreList) {
		
		//ActivityInstance referenceAI = outputScoreList.get(this.getValuesAsTreeSet(inQueue).last());
		//if (this.priorityType.equalsIgnoreCase(ConstantValues.queueTypePriorit_AlphabeticFIFO)) {
		//	PriorityAlphabeticFIFOQueue queueClass = new PriorityAlphabeticFIFOQueue(inQueue, outputScoreList, this.priorityAttributeName); 
		//	sortedPriorityQueue = queueClass.getExpectedQueue();
		//	return sortedPriorityQueue.get(referenceAI);
		//}
		TreeSet<Integer> theValues = this.getValuesAsTreeSet(inQueue);
		return theValues.last();
	}

	public Integer getClosestOutputPosition(TreeMap<WorkItem, Integer> inQueue,
			TreeMap<Integer, ActivityInstance> activityList) {
		TreeSet<Integer> theValues = this.getValuesAsTreeSet(inQueue);
		return theValues.first();
	}

}
