package org.processmining.plugins.resourcePattern.queueAnalysis.presentation.mvc;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.ItemSelectable;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.TreeMap;

import javax.swing.DefaultListModel;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;

import org.apache.commons.math3.stat.StatUtils;
//import org.apache.commons.math.stat.StatUtils;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.DateAxis;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYItemRenderer;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.chart.title.TextTitle;
import org.jfree.data.time.MovingAverage;
import org.jfree.data.time.Second;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.ui.HorizontalAlignment;
import org.jfree.ui.RectangleEdge;
import org.jfree.ui.RectangleInsets;
import org.jfree.ui.VerticalAlignment;
import org.processmining.plugins.resourcePattern.ActivityInstance;
import org.processmining.plugins.resourcePattern.ConstantValues;
import org.processmining.plugins.resourcePattern.presentation.Controller;
import org.processmining.plugins.resourcePattern.queueAnalysis.QueueAnalysis;
import org.processmining.plugins.resourcePattern.utility.Event;

public class QueueController extends Controller {
	private QueueViewer qv;
	private ArrayList<Event> data;
	
	public QueueController(ArrayList<Event> allWithinEvents, QueueViewer qv) {
		super(allWithinEvents, qv);
		this.data = allWithinEvents;
		this.qv=qv;
		
		qv.getOptionPanel().addSelectListener(new SelectListener());
		qv.getOptionPanel().addDisplayListener(new DisplayListener());
	}
	
	class SelectListener implements ItemListener {

		public void itemStateChanged(ItemEvent e) {
		
			ItemSelectable is  = e.getItemSelectable();
			Object selected[] = is.getSelectedObjects();
			String theSelected = (String) selected[0];
			System.out.println("The selected is: " + theSelected);
			
			/*if (theSelected.equalsIgnoreCase(ConstantValues.queueTypePriority)) {
				qv.getOptionPanel().getPriorityAttributeBox().setEnabled(true);
				qv.getOptionPanel().getBeginTypeBox().setEnabled(true);
				qv.getOptionPanel().getEndTypeBox().setEnabled(true);
				qv.getOptionPanel().getGroupByChoice().setEnabled(true);
			} */
			
			if (theSelected.equalsIgnoreCase(ConstantValues.scopeTypeActivity)) {
				DefaultListModel<String> listModel = new DefaultListModel<String>();
				for(String key: qv.getOptionPanel().getActivityList()) {
					listModel.addElement(key);
				}
				qv.getOptionPanel().getGroupByChoice().removeAll();
				qv.getOptionPanel().getGroupByChoice().setModel(listModel);
				qv.getOptionPanel().getBeginTypeBox().setEnabled(true);
				qv.getOptionPanel().getEndTypeBox().setEnabled(true);
				qv.getOptionPanel().getGroupByChoice().setEnabled(true);
			} 
			
			if (theSelected.equalsIgnoreCase(ConstantValues.scopeTypeWorkload)) {
				DefaultListModel<String> listModel = new DefaultListModel<String>();
				for(String key: qv.getOptionPanel().getResourceList()) {
					listModel.addElement(key);
				}
				qv.getOptionPanel().getGroupByChoice().removeAll();
				qv.getOptionPanel().getGroupByChoice().setModel(listModel);
				
				qv.getOptionPanel().getBeginTypeBox().setEnabled(true);
				qv.getOptionPanel().getEndTypeBox().setEnabled(true);
				qv.getOptionPanel().getGroupByChoice().setEnabled(true);
			} 
			
			if (theSelected.equalsIgnoreCase(ConstantValues.scopeTypeCase)) {
				qv.getOptionPanel().getBeginTypeBox().setSelectedItem("start");
				qv.getOptionPanel().getEndTypeBox().setSelectedItem("complete");
				qv.getOptionPanel().getBeginTypeBox().setEnabled(false);
				qv.getOptionPanel().getEndTypeBox().setEnabled(false);
				qv.getOptionPanel().getGroupByChoice().setEnabled(false);
				
			} 
			
			/*if {
				qv.getOptionPanel().getBeginTypeBox().setEnabled(true);
				qv.getOptionPanel().getEndTypeBox().setEnabled(true);
				qv.getOptionPanel().getPriorityAttributeBox().setEnabled(false);
				qv.getOptionPanel().getBeginTypeBox().setEnabled(true);
				qv.getOptionPanel().getEndTypeBox().setEnabled(true);
				qv.getOptionPanel().getGroupByChoice().setEnabled(true);
			}*/
			
		}
		
	}

	class DisplayListener implements ActionListener{
		HashMap<String, TreeMap<Integer,ActivityInstance>> result=null;
		HashMap<String, TreeMap<Date, Integer>> queueLength = null;
		
		public void actionPerformed(ActionEvent arg0) {
			QueueOptionPanel optionPanel = qv.getOptionPanel();
			JPanel ta = qv.getGraphCanvas();
			HashMap<String, String> actionParameters = getChosenParameter(optionPanel);
			
			QueueAnalysis qa = new QueueAnalysis(data,actionParameters);
			try {
				 result = qa.assessQueue();
				 queueLength = qa.getQueueLength();
				 
				 for (String groupBykey: result.keySet()) {
					TreeMap<Integer, ActivityInstance> perGroupScores = result.get(groupBykey);
					for (Integer i: perGroupScores.keySet()) {
						ActivityInstance ai = perGroupScores.get(i);
						if (ai.getQueueScore()==null || ai.getAdjustedScore()==null) {
							System.out.println("serdfdas");
						}		
					}
				}
				 displayGraph(actionParameters, ta);
				 qv.revalidate();
				 qv.repaint();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		private HashMap<String, String> getChosenParameter(QueueOptionPanel optionPanel) {
			JComboBox<String> queueTypesBox = optionPanel.getQueueTypeComboBox();
			JComboBox<String> scopeTypeBox = optionPanel.getScopeTypeComboBox();
			JComboBox<String> beginTypeBox = optionPanel.getBeginTypeBox();
			JComboBox<String> endTypeBox = optionPanel.getEndTypeBox();
			JRadioButton noFFButton = optionPanel.getNoFF();
			JRadioButton normalFFButton = optionPanel.getNormalDistribitionFF();
			JRadioButton expFFButton = optionPanel.getExponentialDistributionFF();
			JRadioButton poissonFFButton = optionPanel.getPoissonDistributionFF();
			JRadioButton logisticFFButton = optionPanel.getLogisticDistributionFF();
			JRadioButton expoFFButton = optionPanel.getLogNormalDistributionFF();
			JComboBox<String> priorityAttributeName = optionPanel.getPriorityAttributeBox();
			JRadioButton normalCalcButton = optionPanel.getNormalCalculationRadioButton();
			JRadioButton ignoreCalcButton = optionPanel.getIgnoreCalculationRadioButton();
			JRadioButton halfCalcButton = optionPanel.getHalfMarkRadioButton();
			JList<String> groupByChoiceBox = optionPanel.getGroupByChoice();
			HashMap<String,String> params = new HashMap<String, String>();
			JCheckBox originalScoreCheck = optionPanel.getOriginalScoreCheck();
			JCheckBox adjustedScoreCheck = optionPanel.getAdjustedScoreCheck();
			JCheckBox movingAverageScoreCheck = optionPanel.getMovingAverageScoreCheck();
			
			params.put(ConstantValues.chosenQueueTypeOption, (String) queueTypesBox.getSelectedItem());
			params.put(ConstantValues.chosenScopeTypeOption, (String) scopeTypeBox.getSelectedItem());
			params.put(ConstantValues.chosenBeginTypeOption, (String) beginTypeBox.getSelectedItem());
			params.put(ConstantValues.chosenEndTypeOption, (String) endTypeBox.getSelectedItem());
			
			if (params.get(ConstantValues.chosenQueueTypeOption).equalsIgnoreCase(ConstantValues.queueTypePriority)) {
				params.put(ConstantValues.chosenPriorityAttributeNameOption, (String) priorityAttributeName.getSelectedItem());
			}
			
			HashSet<String> chosenList = new HashSet<String>();
			if (groupByChoiceBox.getSelectedValuesList().isEmpty()) {
				if (params.get(ConstantValues.chosenScopeTypeOption).equalsIgnoreCase(ConstantValues.scopeTypeActivity)) {
					chosenList = optionPanel.getActivityList();
				} else if (params.get(ConstantValues.chosenScopeTypeOption).equalsIgnoreCase(ConstantValues.scopeTypeWorkload)) {
					chosenList = optionPanel.getResourceList();
				}
			} else {
				List<String> chosenGroupBy_list = groupByChoiceBox.getSelectedValuesList();
				for(String chosenItem: chosenGroupBy_list) {
					chosenList.add(chosenItem);
				}
			}
			String selectedValuesString="";
			if (!params.get(ConstantValues.chosenScopeTypeOption).equalsIgnoreCase(ConstantValues.scopeTypeCase)) {
				for (String selected: chosenList) {
					selectedValuesString += ","+selected;
				}
				params.put(ConstantValues.chosenGroupByChoice, selectedValuesString.substring(1,selectedValuesString.length()));
			} else {
				params.put(ConstantValues.chosenGroupByChoice, "");
			}
			
			if(noFFButton.isSelected()) {
				params.put(ConstantValues.chosenForgetFactor, ConstantValues.noFF);
			} else if (normalFFButton.isSelected()){
				params.put(ConstantValues.chosenForgetFactor, ConstantValues.normalFF);
			} else if (expFFButton.isSelected()) {
				params.put(ConstantValues.chosenForgetFactor, ConstantValues.expFF);
			} else if (poissonFFButton.isSelected()) {
				params.put(ConstantValues.chosenForgetFactor, ConstantValues.poissonFF);
			} else if (logisticFFButton.isSelected()) {
				params.put(ConstantValues.chosenForgetFactor, ConstantValues.logisticExpFF);
			} else if (expoFFButton.isSelected()) {
				params.put(ConstantValues.chosenForgetFactor, ConstantValues.numberEFF);
			}
			
			if (normalCalcButton.isSelected()) {
				params.put(ConstantValues.chosenQueueOneTreatment, ConstantValues.normalCaluclation);
			} else if (ignoreCalcButton.isSelected()) {
				params.put(ConstantValues.chosenQueueOneTreatment, ConstantValues.ignoreCalculation);
			} else if (halfCalcButton.isSelected()) {
				params.put(ConstantValues.chosenQueueOneTreatment, ConstantValues.halfMarkCalculation);
			}
			
			if (originalScoreCheck.isSelected()) {
				params.put(ConstantValues.originalScoreGraph, "true");
			} else {
				params.put(ConstantValues.originalScoreGraph, "false");
			}
			if (adjustedScoreCheck.isSelected()) {
				params.put(ConstantValues.adjustedScoreGraph, "true");
			} else {
				params.put(ConstantValues.adjustedScoreGraph, "false");
			}
			if (movingAverageScoreCheck.isSelected()) {
				params.put(ConstantValues.movingAverageAdjustedScoreGraph, "true");
			} else {
				params.put(ConstantValues.movingAverageAdjustedScoreGraph, "false");
			}
			return params;
		}

		private void displayGraph(HashMap<String, String> actionParameters, JPanel ta) {
			JFreeChart evolutionChart=drawGraph(actionParameters);
			
			ta.removeAll();
			
			ChartPanel chartPanel = new ChartPanel(evolutionChart);
			chartPanel.setLayout(new BorderLayout());
			chartPanel.setDomainZoomable(true);
			chartPanel.setRangeZoomable(true);
			
			//chartPanel.setMaximumDrawWidth(10000);
			//chartPanel.setMaximumDrawHeight(10000);
			//chartPanel.setAutoscrolls(true);
			
			JScrollPane graphPanel = new JScrollPane(chartPanel, 
					ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
					ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			ta.add(graphPanel, BorderLayout.CENTER);
			System.out.println("Chart panel added to text area");
			ta.revalidate();
			ta.repaint();
			ta.setVisible(true);
		}

		private JFreeChart drawGraph(HashMap<String, String> actionParameters) {
			TimeSeriesCollection dataSet = new TimeSeriesCollection();
			TimeSeriesCollection queueLengthDataSetTS = new TimeSeriesCollection();
			
			String[] selectedGroupByChoices = actionParameters.get(ConstantValues.chosenGroupByChoice).split(",");
			String chosenScopeType = actionParameters.get(ConstantValues.chosenScopeTypeOption);
			String chosenQueueOneTreatment = actionParameters.get(ConstantValues.chosenQueueOneTreatment);
			ArrayList<String> selectedGroupByList = new ArrayList<String>();
			for (int i=0; i<selectedGroupByChoices.length; i++){
				selectedGroupByList.add(selectedGroupByChoices[i]);
				System.out.println("Selected group by choices: " + selectedGroupByChoices[i]);
			}
			
			 for (String groupBykey: result.keySet()) {
				TreeMap<Integer, ActivityInstance> perGroupScores = result.get(groupBykey);
				int size = perGroupScores.size();
				for (Integer i: perGroupScores.keySet()) {
					ActivityInstance ai = perGroupScores.get(i);
					if (i==14035) {
						System.out.println("fdasfd");
					
					}
					if (ai==null) {
						System.out.println("fdsafd");
					}
					if (ai.getQueueScore()==null || ai.getAdjustedScore()==null) {
						System.out.println("serdfdas");
					}		
				}
			}
			 
			String legend="Score:\n";
			for (String groupByKey: result.keySet()) {
				if (!chosenScopeType.equalsIgnoreCase(ConstantValues.scopeTypeCase) && !selectedGroupByList.contains(groupByKey)) {
					continue;
				}
				
				//Need to get the euclidean distance for each series
				//now, if we are goign to ignore queue with length one, then 
				//we need to chagne the values to be summed up in the final Euclidean distance to zero
				//and reduce the divisor to those number that count. 
				//If we do not ignore queue length of one entry, the ignoredEntries counter will stay at 0,
				//those not affectinv the final calculation
				int ignoredEntries=0;
				double noOfEntries = result.get(groupByKey).size();
				double[] aValues = new double[result.get(groupByKey).size()];
				double[] bValues = new double[result.get(groupByKey).size()];
				double[] aValues_adjusted = new double[result.get(groupByKey).size()];
				double[] bValues_adjusted = new double[result.get(groupByKey).size()];
				double[] normalValues = new double[result.get(groupByKey).size()];
				double[] adjustedValues = new double[result.get(groupByKey).size()];
				int i=0;
				for(Integer theI: result.get(groupByKey).keySet()) {
					ActivityInstance ai = result.get(groupByKey).get(theI);
					aValues[i] = 0.0;
					try {
						ai.getQueueScore(); 
					} catch (Exception e) {
						
						System.out.println("something is wrong");
					}
					bValues[i] = 1 - ai.getQueueScore();
					
					//System.out.println("The queue score is "+ai.getQueueScore());
					aValues_adjusted[i] = 0.0;
					bValues_adjusted[i] = ai.getAdjustedScore();
					
					// Change
					if (bValues[i] == 2 && bValues_adjusted[i]==-1) {
						bValues[i] = 0;
						bValues_adjusted[i] = 0;
						ignoredEntries++;
					}
				
//					normalValues[i] = Math.pow( (aValues[i] - bValues[i]), 2);
//					adjustedValues[i] = Math.pow((aValues_adjusted[i] - bValues_adjusted[i]), 2);
					
					
					normalValues[i] = bValues[i];
					adjustedValues[i] =  bValues_adjusted[i];
					i = i+1;
				}
				
				
//				double sumNormalDistance = 0;
//				double sumAdjustedDistance = 0;
				
//				for (int j = 0; j < result.get(groupByKey).size(); j++)
//				{
//					System.out.println("** normal = "+normalValues[j]+"     ** adjusted = "+adjustedValues[j]);
//					//System.out.println("** adjusted = "+adjustedValues[j]);
//				}
//				double normalDistance = Math.sqrt(StatUtils.sum(normalValues)) / (noOfEntries - ignoredEntries);
//				double adjustedDistance = Math.sqrt(StatUtils.sum(adjustedValues)) / (noOfEntries - ignoredEntries);
				
				double normalDistance = -1;
				double adjustedDistance = -1;
				if (noOfEntries>0){
					normalDistance = StatUtils.sum(normalValues)/(noOfEntries - ignoredEntries);
				//	normalDistance = Math.sqrt(StatUtils.sum(normalValues));
					System.out.println("The sum is "+ StatUtils.sum(normalValues));
					System.out.println("The No of Entries is "+ (noOfEntries - ignoredEntries));
					//adjustedDistance = Math.sqrt(StatUtils.sum(adjustedValues)/(noOfEntries - ignoredEntries)) ;
					adjustedDistance = StatUtils.sum(adjustedValues)/(noOfEntries - ignoredEntries) ;
				//	adjustedDistance = Math.sqrt(StatUtils.sum(adjustedValues));
				
				}
				
				legend += groupByKey + ":" + String.format("%.4f", normalDistance) +  "       \t"+ 
				groupByKey+"_adjusted:" + String.format("%.4f", adjustedDistance)+"\n";
				
				
				
				/*EuclideanDistance e_distance = new EuclideanDistance();
				Double normalDistance_x = e_distance.compute(aValues, bValues) ;
				Double adjustedDistance_x = e_distance.compute(aValues_adjusted, bValues_adjusted);*/
				
				TreeMap<Integer, ActivityInstance> queuePatternMap = result.get(groupByKey);
				TimeSeries dataSeries = new TimeSeries(groupByKey);
				TimeSeries dataSeriesAdjusted=null;
				TimeSeries queueLengthTS = new TimeSeries(groupByKey+"_queueLength");
				TimeSeries movingAverage_adjusted = new TimeSeries(groupByKey+"_movingAverageAdjusted");
				dataSeries.setDescription(groupByKey);
				if ( !actionParameters.get(ConstantValues.chosenForgetFactor).equalsIgnoreCase(ConstantValues.noFF)) {
					dataSeriesAdjusted = new TimeSeries(groupByKey+"_adjusted");
					dataSeriesAdjusted.setDescription(groupByKey+"_adjusted");
				}
				
							
				
				//need to change key to date to fit TimeSeries data
				//we will not include any entries where the queue score is -1
				TreeMap<Date, ActivityInstance> queuePatternData = new TreeMap<Date, ActivityInstance>();
				for(Integer order: queuePatternMap.keySet()) {
					if (queuePatternMap.get(order).getQueueScore()!=-1) {
						queuePatternData.put(queuePatternMap.get(order).getOutTS(), 
								queuePatternMap.get(order));
					}
				}
				
				for(Date theDate : queuePatternData.keySet()) {
					dataSeries.add(new Second(theDate),
							Math.abs(1-queuePatternData.get(theDate).getQueueScore()));
					if ( !actionParameters.get(ConstantValues.chosenForgetFactor).equalsIgnoreCase(ConstantValues.noFF) &&
							dataSeriesAdjusted!=null) {
						dataSeriesAdjusted.add(new Second(theDate),
								//The adjustedScore is already derived from 1-queueScore, so no need to do another 1-queuescore operation again
								//Math.abs(1-queuePatternData.get(theDate).getAdjustedScore()));
								Math.abs(queuePatternData.get(theDate).getAdjustedScore()));
					}
				}
				
				if ( !actionParameters.get(ConstantValues.chosenForgetFactor).equalsIgnoreCase(ConstantValues.noFF) &&
						dataSeriesAdjusted!=null) {
						movingAverage_adjusted = MovingAverage.createMovingAverage(dataSeriesAdjusted, "movingAverage",	10*24*3600, 24);
				}
								
				TreeMap<Date, Integer> queueLengthPerGroup = queueLength.get(groupByKey);
				for (Date theDate: queueLengthPerGroup.keySet()) {
					queueLengthTS.add(new Second(theDate), queueLengthPerGroup.get(theDate));
				}
				
				Boolean isDisplayOriginalScore = new Boolean(actionParameters.get(ConstantValues.originalScoreGraph));
				Boolean isDisplayAdjustedScore = new Boolean(actionParameters.get(ConstantValues.adjustedScoreGraph));
				Boolean isDisplayMovingAverageScore = new Boolean(actionParameters.get(ConstantValues.movingAverageAdjustedScoreGraph));
				
				if (isDisplayOriginalScore) {
					dataSet.addSeries(dataSeries);
				}
				
				if (!actionParameters.get(ConstantValues.chosenForgetFactor).equalsIgnoreCase(ConstantValues.noFF) &&
						dataSeriesAdjusted!=null) {
					if (isDisplayAdjustedScore) {
						dataSet.addSeries(dataSeriesAdjusted);
					}
					if (isDisplayMovingAverageScore) {
						dataSet.addSeries(movingAverage_adjusted);
					}
				}
				
				queueLengthDataSetTS.addSeries(queueLengthTS);
				
			}
			
			System.out.println("There are " + dataSet.getSeriesCount() + " series.");
					
			JFreeChart theChart=null;
			theChart = ChartFactory.createTimeSeriesChart(
					"Queue Style History", "Timestamp", 
					"Queue Score",
					dataSet, 
					true, true, false);
			
			theChart.addSubtitle(new TextTitle(legend, new Font("Dialog", Font.PLAIN, 9), Color.black, RectangleEdge.BOTTOM, HorizontalAlignment.CENTER,
					VerticalAlignment.BOTTOM, RectangleInsets.ZERO_INSETS));
			
			System.out.println(legend);
			
			XYPlot plot = (XYPlot) theChart.getPlot();
			plot.setDataset(1, queueLengthDataSetTS);
			plot.setRangeAxis(1, new NumberAxis());
			
			plot.setBackgroundPaint(Color.LIGHT_GRAY);
	        plot.setDomainGridlinePaint(Color.white);
	        plot.setRangeGridlinePaint(Color.white);
	        //plot.setAxisOffset(new RectangleInsets(5.0, 5.0, 5.0, 5.0));
	        plot.setDomainCrosshairVisible(true);
	        plot.setRangeCrosshairVisible(true);
	        
	        XYItemRenderer r = plot.getRenderer(0);
	        if (r instanceof XYLineAndShapeRenderer) {
	              XYLineAndShapeRenderer renderer = (XYLineAndShapeRenderer) r;
	              renderer.setBaseShapesVisible(true);
	              renderer.setBaseShapesFilled(true);
	              renderer.setDrawSeriesLineAsPath(true);
	        }
	        
	        
	        XYLineAndShapeRenderer renderer2 = new XYLineAndShapeRenderer();
			renderer2.setBaseShapesFilled(true);
			renderer2.setDrawSeriesLineAsPath(false);
			plot.setRenderer(1, renderer2);
			
	        
	        DateAxis xAxis = (DateAxis) plot.getDomainAxis();
	        xAxis.setAutoRange(true);
	        
	    	plot.mapDatasetToRangeAxis(0,  0);
			plot.mapDatasetToRangeAxis(1,  1);
	        plot.getRangeAxis(0).setRange(-0.5, 1.5);
	        plot.getRangeAxis(1).setRange(0, 500);
			//plot.getRangeAxis().setRange(-0.5, 1.5);

			return theChart;
			
			//XYPlot plot = new XYPlot();
			//plot.setDataset(0, dataSet);
			//plot.setDataset(1, queueLengthDataSetTS);
			
			//plot.setRenderer(0, new XYSplineRenderer());
			//XYSplineRenderer renderer = new XYSplineRenderer();
			//renderer.setSeriesFillPaint(0,  Color.BLUE);
			//plot.setRenderer(1, renderer);
			
			//plot.setDomainAxis(new DateAxis());
			//plot.setRangeAxis(0, new NumberAxis());
			//plot.setRangeAxis(1, new NumberAxis());
			
		
			
		}
		
	}
}
