package org.processmining.plugins.resourcePattern.queueAnalysis.presentation.mvc;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.resourcePattern.presentation.Viewer;

public class QueueViewer extends Viewer{
	QueueOptionPanel optionPanel = null;
	JScrollPane graphPanel = null;
	JPanel graphCanvas = null;
	JSplitPane mainDisplay = null;
		
	public QueueViewer(PluginContext context, XLog log) throws Exception {
		super(context);
		//this.results = (HashMap<String, TreeMap<Integer, ActivityInstance>>) results;
		initializeGUI(log);
	}
		
	private void initializeGUI(XLog log) throws Exception {
		optionPanel = new QueueOptionPanel(log);
		JPanel theOptionPanel = optionPanel.getOptionPanel();
		
		graphCanvas = new JPanel();
		graphCanvas.setLayout(new BorderLayout());
		
		//graphCanvas.setPreferredSize(new Dimension(2000,2000));

		mainDisplay = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, theOptionPanel, graphCanvas);
		mainDisplay.setDividerLocation(165);
		mainDisplay.setDividerSize(3);
		mainDisplay.setOneTouchExpandable(true);
		
		setLayout(new BorderLayout());
		this.add(mainDisplay, BorderLayout.CENTER);
		validate();
		this.repaint();
	}
		
	public QueueOptionPanel getOptionPanel() {
		return this.optionPanel;
	}
	
	public JPanel getGraphCanvas() {
		return this.graphCanvas;
	}
	
	public JScrollPane getGraphPanel() {
		return this.graphPanel;
	}

}
