package org.processmining.plugins.resourcePattern.queueAnalysis.priority;

import org.processmining.plugins.resourcePattern.ActivityInstance;
import org.processmining.plugins.resourcePattern.ConstantValues;

public class PriorityAlphabeticFIFO extends PriorityQueueItem implements Comparable<PriorityAlphabeticFIFO>{
	
	
	public PriorityAlphabeticFIFO(ActivityInstance ai, String priorityAttributeName) {
		this.ai = ai; 
		this.priorityAttributeName = priorityAttributeName;		
		this.wi = ai.getWi();
	}

	
	@Override
	public int compareTo(PriorityAlphabeticFIFO o) {
		String attributeValueA;
		String attributeValueB;
				
		if (this.priorityAttributeName.equalsIgnoreCase(ConstantValues.xesCaseID) || 
				this.priorityAttributeName.equalsIgnoreCase(ConstantValues.caseID)) {
			attributeValueA = this.getWi().getCaseID();
			attributeValueB = o.getWi().getCaseID();
		} else if(this.priorityAttributeName.equalsIgnoreCase(ConstantValues.xesActivityName) ||
				this.priorityAttributeName.equalsIgnoreCase(ConstantValues.activity)) {
			attributeValueA = this.getWi().getActivity();
			attributeValueB = o.getWi().getActivity();
		} else if (this.priorityAttributeName.equalsIgnoreCase(ConstantValues.resource) ||
				this.priorityAttributeName.equalsIgnoreCase(ConstantValues.xesResource)) {
			attributeValueA = this.getWi().getResource();
			attributeValueB = o.getWi().getResource();
		} else if (this.priorityAttributeName.equalsIgnoreCase(ConstantValues.resourceGroup) ||
				this.priorityAttributeName.equalsIgnoreCase(ConstantValues.xesGroup)) {
			attributeValueA = this.getWi().getResourceGroup();
			attributeValueB = o.getWi().getResourceGroup();
		} else {
			attributeValueA = this.getWi().getEventAttributes().get(this.priorityAttributeName);
			attributeValueB = o.getWi().getEventAttributes().get(this.priorityAttributeName);
		} 
		
		if (attributeValueA.compareTo(attributeValueB) == 0) {
			return this.ai.getInTS().compareTo(o.ai.getInTS());
		} else {
			try {
				int value2 = (new Integer(attributeValueA)).compareTo(new Integer(attributeValueB));
				return value2 ;
			} catch (Exception e) {
				int value = attributeValueA.compareTo(attributeValueB);
				return value;
			}
		}
	}
	
	public String toString() {
		return this.ai.toString() + "::" + getWi().getCaseID() + "," + this.ai.getWi().getActivity() + "," + this.ai.getWi().getResource() + "," +
				this.ai.getInTS();
	}
	
	
}
