package org.processmining.plugins.resourcePattern.queueAnalysis.priority;

import java.util.HashMap;
import java.util.TreeMap;

import org.processmining.plugins.resourcePattern.ActivityInstance;
import org.processmining.plugins.resourcePattern.WorkItem;

public class PriorityAlphabeticFIFOQueue {
	
	TreeMap<PriorityAlphabeticFIFO, Integer> sortedQueue;
	HashMap<ActivityInstance, Integer> expectedQueue;
	

	public PriorityAlphabeticFIFOQueue(TreeMap<WorkItem, Integer> inQueue, TreeMap<Integer, ActivityInstance> outputScoreList,
			String priorityAttributeName) {
		super();
		sortedQueue = new TreeMap<PriorityAlphabeticFIFO, Integer>();
		expectedQueue = new HashMap<ActivityInstance, Integer>();
		
		for(WorkItem wi: inQueue.keySet()) {
			ActivityInstance ai = outputScoreList.get(inQueue.get(wi));
			PriorityAlphabeticFIFO item = new PriorityAlphabeticFIFO(ai, priorityAttributeName);
			sortedQueue.put(item, inQueue.get(wi));
		}
		
		/*TreeSet<Integer> orderTree = new TreeSet<Integer>();
		for (Integer order : sortedQueue.values()) {
			orderTree.add(order);
		}
		
		Integer minimumIndex = orderTree.first();
		Integer maximumIndex = orderTree.first() + orderTree.size() - 1;
		int currentIndex = minimumIndex;
		
		for (PriorityAlphabeticFIFO sortedItem: sortedQueue.keySet()) {
			sortedQueue.put(sortedItem, currentIndex);
			currentIndex++;
		}
		
		assert (currentIndex-1)==maximumIndex;*/
		
		for (PriorityAlphabeticFIFO aiItem: sortedQueue.keySet()) {
			//System.out.println(aiItem.getAi().toString() + ":" + sortedQueue.get(aiItem));
			expectedQueue.put(aiItem.getAi(), sortedQueue.get(aiItem));
		}
		
	}

	public TreeMap<PriorityAlphabeticFIFO, Integer> getSortedQueue() {
		return sortedQueue;
	}

	public HashMap<ActivityInstance, Integer> getExpectedQueue() {
		return expectedQueue;
	}

	public void setExpectedQueue(HashMap<ActivityInstance, Integer> expectedQueue) {
		this.expectedQueue = expectedQueue;
	}

	public void setSortedQueue(TreeMap<PriorityAlphabeticFIFO, Integer> sortedQueue) {
		this.sortedQueue = sortedQueue;
	}

	

}
