package org.processmining.plugins.resourcePattern.utility;

import java.util.Date;
import java.util.HashMap;

public class Event implements Comparable<Event> {
	private String caseID = null;
	private Date timestamp = null;
	private String activity = null;
	private String resource = null;
	private String resourceGroup = null;
	private String transition = null;
	private HashMap<String, String> eventAttributes = null;
	private Integer taskInstance = null;
	
	public Event() {
		caseID=new String();
		timestamp=new Date();
		activity=new String();
		transition=new String();
		resource=new String();
		resourceGroup=new String();
		taskInstance = new Integer(0);
		eventAttributes=new HashMap<String, String>();
	}
	
	public Integer getTaskInstance() {
		return taskInstance;
	}

	public void setTaskInstance(Integer taskInstance) {
		this.taskInstance = taskInstance;
	}

	public Event(String caseID, Date timestamp, String activity, Integer taskInstance, String resource,
			String resourceGroup, String transition, HashMap<String, String> eventAttributes) {
		this.caseID=caseID;
		this.timestamp = timestamp;
		this.activity = activity;
		this.taskInstance = taskInstance;
		this.resource = resource;
		this.resourceGroup = resourceGroup;
		this.transition=transition;
		this.eventAttributes = eventAttributes;
	}
	
	public Event(String caseID, Date timestamp, String activity, String resource,
			String resourceGroup, String transition, HashMap<String, String> eventAttributes) {
		this.caseID=caseID;
		this.timestamp = timestamp;
		this.activity = activity;
		//this.taskInstance = taskInstance;
		this.resource = resource;
		this.resourceGroup = resourceGroup;
		this.transition=transition;
		this.eventAttributes = eventAttributes;
	}
	
	public String getCaseID() {
		return caseID;
	}
	public void setCaseID(String caseID) {
		this.caseID = caseID;
	}
	public Date getTimestamp() {
		return timestamp;
	}
	public void setTimestamp(Date timestamp) {
		this.timestamp = timestamp;
	}
	public String getActivity() {
		return activity;
	}
	public void setActivity(String activity) {
		this.activity = activity;
	}
	public String getResource() {
		return resource;
	}
	public void setResource(String resource) {
		this.resource = resource;
	}
	public String getResourceGroup() {
		return resourceGroup;
	}
	public void setResourceGroup(String resourceGroup) {
		this.resourceGroup = resourceGroup;
	}
	public HashMap<String, String> getEventAttributes() {
		return eventAttributes;
	}
	public void setEventAttributes(HashMap<String, String> eventAttributes) {
		this.eventAttributes = eventAttributes;
	}
	public String getTransition() {
		return this.transition;
	}
	public void setTransition(String transition) {
		this.transition=transition;
	}
	
	@Override
	public int compareTo(Event o) {
		//return this.caseID.compareTo(o.caseID);
		if(o==null) {
			throw new NullPointerException();
		} 
		if (this.equals(o)) {
			return 0;
		} 
		if (!(this.timestamp.getTime()==o.timestamp.getTime())) {
			return this.timestamp.compareTo(o.getTimestamp());
		} 
		if (this.getCaseID().equalsIgnoreCase(o.getCaseID()) && this.getActivity().equalsIgnoreCase(o.getActivity())) {
			if (!this.transition.equalsIgnoreCase(o.getTransition())) {
				if	((this.transition.equalsIgnoreCase("schedule") && o.transition.equalsIgnoreCase("assign")) ||
					(this.transition.equalsIgnoreCase("schedule") && o.transition.equalsIgnoreCase("start")) ||
					(this.transition.equalsIgnoreCase("schedule") && o.transition.equalsIgnoreCase("complete")) ||
					(this.transition.equalsIgnoreCase("assign") && o.transition.equalsIgnoreCase("start")) ||
					(this.transition.equalsIgnoreCase("assign") && o.transition.equalsIgnoreCase("complete")) ||
					(this.transition.equalsIgnoreCase("start") && o.transition.equalsIgnoreCase("complete"))) {
					return -1;
				} else {
					return 1;
				}
			} else {
				return this.caseID.compareTo(o.caseID);
			}
		} else {
			return this.caseID.compareTo(o.caseID);
		}
		
	}
	
	/*public boolean equals(Event o) {
		if (o==null) {
			return false;
		} else if (this.getClass()!=o.getClass()) {
			return false;
		} else if ( !(this.getCaseID().equalsIgnoreCase(o.getCaseID())) ||
					!(this.getActivity().equalsIgnoreCase(o.getActivity())) ||
					!(this.getTimestamp().getTime()==o.getTimestamp().getTime()) ||
					!(this.getTransition().equalsIgnoreCase(o.getTransition())) ||
					!(this.getTaskInstance()==o.getTaskInstance())) {
			return false; 
		} else {		
			return true;
		}
	}*/
	
	public Event deepCopy(Event e) {
		Event newEvent = new Event(e.getCaseID(), e.getTimestamp(), e.getActivity(), e.getTaskInstance(), e.getResource(), e.getResourceGroup(),
				e.getTransition(), e.getEventAttributes());
		return newEvent;
	}
	
	@Override
	public String toString() {
		return this.getCaseID()+","+this.getActivity()+","+this.getTimestamp()+","+this.getTransition();
	}
	
}
