package org.processmining.plugins.resourcePattern.utility;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.TimeZone;

import javax.swing.JRadioButton;

import org.processmining.framework.util.ui.widgets.ProMComboBox;
import org.processmining.framework.util.ui.widgets.ProMTextField;
import org.processmining.plugins.resourcePattern.ConstantValues;

public class Parameter {
	public HashMap<String, Object> processParameter(HashMap<String, Object> paramSet) throws Exception {
		HashMap<String, Object> cleanedParamSet = new HashMap<String, Object>();
		Set<String> keySet = paramSet.keySet();
		Iterator<String> keyIterator = keySet.iterator();
		while (keyIterator.hasNext()){
			String theKey = keyIterator.next();
						
			if (theKey.equalsIgnoreCase(ConstantValues.paramName01startDate) || 
					theKey.equalsIgnoreCase(ConstantValues.paramName02endDate)) {
				ProMTextField theValueField = (ProMTextField) paramSet.get(theKey);
				Date cleanedValue = cleanDate(theValueField.getText());
				cleanedParamSet.put(theKey, cleanedValue);
			}
			
			if (theKey.equalsIgnoreCase(ConstantValues.paramName03HeadType)) {
				String theEventType = "";
				ProMComboBox comboBox = (ProMComboBox) paramSet.get(theKey);
				theEventType = (String) comboBox.getSelectedItem();
				//System.out.println("Selected event type is: "+ theEventType);
				cleanedParamSet.put(theKey, theEventType);
			}
			
			if (theKey.equalsIgnoreCase(ConstantValues.paramName03ATailType)) {
				ProMComboBox endType = (ProMComboBox) paramSet.get(theKey);
				cleanedParamSet.put(theKey, endType.getSelectedItem());
			}
			
			/*if (theKey.equalsIgnoreCase(ConstantValues.paramName04gapTypes)) {
				String gapTypes="";
				String theGapTypes="";
				ProMCheckComboBox checkBox = (ProMCheckComboBox) paramSet.get(theKey);
				if (checkBox!=null){
					Collection<String> selectedGapTypes= checkBox.getSelectedItems();
					for(Object attribute : selectedGapTypes) {
						String theGap = (String) attribute;
						String theGapName="";
						if (theGap.equalsIgnoreCase(ConstantValues.caseGapTypeDesc)) {
							theGapName=ConstantValues.caseGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.resourceGapTypeDesc)) {
							theGapName=ConstantValues.resourceGapType;
						}
						
						
						if (theGap.equalsIgnoreCase(ConstantValues.minimumGapTypeDesc)) {
							theGapName=ConstantValues.minimumGapType;
						}
						
						if (theGap.equalsIgnoreCase(ConstantValues.resourceCaseGapTypeDesc)||
								theGap.equalsIgnoreCase(ConstantValues.caseResourceGapTypeDesc)) {
							theGapName=ConstantValues.resourceCaseBusyGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.activityGapTypeDesc)) {
							theGapName=ConstantValues.activityGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.taskGapTypeDesc)) {
							theGapName=ConstantValues.taskGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.sojournGapTypeDesc)) {
							theGapName=ConstantValues.sojournGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.shelfGapTypeDesc)) {
							theGapName=ConstantValues.shelfGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.assignmentGapTypeDesc)) {
							theGapName=ConstantValues.assignmentGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.launchGapTypeDesc)) {
							theGapName=ConstantValues.launchGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.activityIdleGapTypeDesc)) {
							theGapName=ConstantValues.activityIdleGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.minShelfGapTypeDesc)) {
							theGapName=ConstantValues.minShelfGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.assignmentIdleGapTypeDesc)) {
							theGapName=ConstantValues.assignmentIdleGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.minLaunchGapTypeDesc)) {
							theGapName=ConstantValues.minLaunchGapType;
						}
						if (theGap.equalsIgnoreCase(ConstantValues.scheduleIdleGapTypeDesc)) {
							theGapName=ConstantValues.scheduleIdleGapType;
						}
						gapTypes += theGapName+",";
					}
					theGapTypes=gapTypes.substring(0, gapTypes.length()-1);
					//System.out.println("Selected case attribute list:" + theGapTypes);
					cleanedParamSet.put(theKey, theGapTypes);
				}
			}	*/
			
			if (theKey.equalsIgnoreCase(ConstantValues.paramName_QQueueType)) {
				ProMComboBox queueTypeBox = (ProMComboBox) paramSet.get(theKey);
				cleanedParamSet.put(theKey, queueTypeBox.getSelectedItem());
				cleanedParamSet.put(theKey, queueTypeBox.getSelectedItem());
			}
			
			if (theKey.equalsIgnoreCase(ConstantValues.paramName_QScopeType)) {
				ProMComboBox scopeTypeBox = (ProMComboBox) paramSet.get(theKey);
				cleanedParamSet.put(theKey, scopeTypeBox.getSelectedItem());
				cleanedParamSet.put(theKey, scopeTypeBox.getSelectedItem());
			}
			
			if (theKey.equalsIgnoreCase(ConstantValues.paramName_QPriorityAttribute)) {
				ProMComboBox priorityTypeBox = (ProMComboBox) paramSet.get(theKey);
				cleanedParamSet.put(theKey, priorityTypeBox.getSelectedItem());
				cleanedParamSet.put(theKey, priorityTypeBox.getSelectedItem());
			}
			
			if (theKey.equalsIgnoreCase(ConstantValues.paramName04ResourceAnalysisType)) {
				JRadioButton[] rbuttons = (JRadioButton[]) paramSet.get(theKey);
				for(int i=0; i<rbuttons.length; i++) {
					if (rbuttons[i].isSelected()) {
						cleanedParamSet.put(theKey,rbuttons[i]);
						break;
					}
				}
			}
		}
		return cleanedParamSet;
	}

	private Date cleanDate(String theValue) throws Exception {
		String[] values = theValue.split("-");
		if (values.length!=3) {
			throw new Exception("There is something wrong with the entered date format");
		}
		DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		formatter.setTimeZone(TimeZone.getTimeZone("GMT+10:00"));
		Integer theDate = new Integer(values[0]);
		Integer theMonth = new Integer(values[1]);
		Integer theYear = new Integer(values[2]);
		Date cleanDate = formatter.parse(theYear+"-"+theMonth+"-"+theDate+" 00:00:00");
		
		return cleanDate;
	}

	
}
